;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;graphische funktion: drwBAR(xpos,ypos,xsize,ysize,line,func)
;function:
;- rechteckiger rahmen relativ zum parameter gefllt (links nach rechts)
;parameter*100/255
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;
;a)rechtwinkligen Rahmen konstruieren:
_DRWbargraph:
	;
	call	_CALCpageSIZ	;bentigten x-pagebereich fr graphBOX berechnen
					;& masken erstellen

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
_DRWbargraphB:
	lds	r16,yCHARsiz
	;beschreibe 64-bit shift-register
	;-> *yCHARsize
_DRWbargraphBloop:
	tst	r16
	breq	_DRWbargraphC
	dec	r16
	set		;clear t-flag
	call	_SFTregA
	jmp	_DRWbargraphloop


_DRWbargraphC:
;	shift register inhalt, falls
;   	erforderlich verschieben
	lds	r16,SFTfactor	;shift-factor 0-7 laden
_DRWbarreadyLOOP:
	tst	r16
	breq	_DRWbargraphD
	clt
	dec	r16
	call	_SFTregA		;x*schieben
	jmp	_DRWbarreadyLOOP
	;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
_DRWbargraphD:
	;zuerst shift-register ins sram
	;shiftregister startadresse
	ldi	zh,high(SFTregST)
	ldi	zl,low(SFTregST)
	st	z+,r2
	st	z+,r3
	st	z+,r1
	st	z+,r5
	st	z+,r6
	st	z+,r7
	st	z+,r8
	st	z,r9	





















;****************************************************************************************
;sub division 16bit/255  (zl parameter | %-result in r1
;****************************************************************************************
_d255iv:
.equ	T2550HOU	=	2550	
.equ	H255UN	=	255
.equ	H127UN	=	127
	;parameter x(8bit)*100
	lds	zl,paraA
	ldi	zh,100
	mul	zl,zh
	mov	zl,r0	;lsb
	mov	zh,r1	;msb
	;
	clr	r1	;10% er counter
	ldi	yl,low(TT2550HOU)
	ldi	yh,high(TT2550HOU)
	ldi	xl,10
	;wie oft gehn 2550 rein?
_THOloop:
	;>=2550
	cpi	zl,low(T2550HOU)	
	ldi	xh,high(T2550HOU)	
	cpc	zh,xh		
	brlo	_HUloop
	;-25550
	sub	zl,yl		;low
	sbc	zh,yh		;high
	add	r1,xl		;+10%
	rjmp	_THOloop
	;
	;wie oft gehn 255 rein
_HUloop:
	ldi	yl,low(H255UN)
	ldi	yh,high(H255UN)
	ldi	xl,1
_HUloopGO:
	;>=255
	cpi	zl,low(H255UN)	
	ldi	xh,high(H255UN)	
	cpc	zh,xh		
	brlo	_HUloopEX
	;-255
	sub	zl,yl		;low
	sbc	zh,yh		;high
	add	r1,xl		;+1000
	rjmp	_HUloopGO

	;rest >127 (dann %+1)
_HUloopEX:
	cpi	zl,low(H127UN)	
	ldi	xh,high(H127UN)	
	cpc	zh,xh		
	brlo	_THOUloopREADY
	;>=127 == +1%
	inc	r1
_THOUloopREADY:
	ret