;backlight dimmer
;.equ	NORMlight	=	0x451	;normal helligkeit
;.equ	DIMlight	=	0x452	;dim helligkeit
;.equ	DIMcntaL	=	0x453	;dimm counter 1 low
;.equ	DIMcntaH	=	0x454	;               high
;.equ	DIMcntbL	=	0x455	;dimm counter 2 low
;.equ	DIMcntbH	=	0x456	;               high

;.equ	DIMflag		=	0x457	;dimm flags

;flags
;.equ	BLred		=	0		;reduziere backlight
;.equ	BLnorm		=	1		;normaler backlight wert


;konstanten
;.equ	DcntA		=	65535
;.equ	DcntB		=	1690
;info: produkt DnctA*DcntB= 110754150 zyklen (runtime ca.10sekunden)
;............................................................................................................................
_BlightA:
		;prfe signal drehratengeber...
		;zuerst push funktion prfen
		lds	r16,DIMflag
		sbrc	r16,BLnorm	;1= drehratenwert aktuell...
		rjmp	_BlightNORM
		;keine aktion...
	
		sbrs r16,BLred	;schon reduziert???
		rjmp	_BlightAX
		jmp		_BlightBACK ;ja reduziert & zurck !!!
		;........................................................
		;starte dimm counters!!!
_BlightNORM:
		lds	r16,DIMflag
		cbr	r16,1<<BLnorm
		sts	DIMflag,r16
		;
		sbrs	r16,BLred
		rjmp	_BlightNORMb	;drehratengeber aktiv & backlight normal !
		;..................
		cbr	r16,1<<BLred
		sts	DIMflag,r16
		lds	r16,NORMlight	;normalen backlightwert laden
		out	ocr1al,r16
		;..................
_BlightNORMb:
		clr	r16
		sts		DIMcntaL,r16
		sts		DIMcntaH,r16
		sts		DIMcntbL,r16
		sts		DIMcntbH,r16
		jmp		_BlightAX
		;.......................................................................................
		;
_BlightAX:
		lds	zl,DIMcntaL
		lds	zh,DIMcntaH
		cpi	zl,low(DcntA)
		ldi	r16,high(DcntA)
		cpc	zh,r16
		;istTIME >= sollTIME ?
		brsh	_BlightB
		;-> time+1 & zurck 
		adiw	zh:zl,1
		sts		DIMcntaL,zl
		sts		DIMcntaH,zh
		jmp		_BlightBACK	;...zurck
		;..............................
		;counter 2 prfen
_BlightB:
		clr	r16
		sts		DIMcntaL,r16
		sts		DIMcntaH,r16
		;
		lds	zl,DIMcntbL
		lds	zh,DIMcntbH
		cpi	zl,low(DcntB)
		ldi	r16,high(DcntB)
		cpc	zh,r16
		;istTIME >= sollTIME ?
		brsh	_BlightC
		adiw	zh:zl,1
		sts		DIMcntbL,zl
		sts		DIMcntbH,zh
		jmp		_BlightBACK	;...zurck
		;...............................
		;nun backlight reduzieren
_BlightC:
		clr	r16
		sts		DIMcntbL,r16
		sts		DIMcntbH,r16
		lds	r16,DIMflag
		sbr	r16,1<<BLred
		sts	DIMflag,r16
		lds	r16,DIMlight
		out	ocr1al,r16
		jmp	_BlightBACK

;............................................................................................................................
_BlightBACK:
	ret