;*************************************************************************
;macros
;<reg>=xl,xh,yl,zl,zh
;*************************************************************************
;graphTXT-macro (txtL<reg>,txtH<reg>,zoomX,zoomY,posX,posY,flag<reg>)
;*************************************************************************
.macro	_graphTXT
	;text adressieren
	sts	TXTpointL,@0	;startadresse textsegment
	sts	TXTpointH,@1
	;x-zoomfaktor
	ldi	yh,@2
	sts	CHARfactorX,yh	
	;y-zoomfaktor
	ldi	yh,@3
	sts	CHARfactorY,yh	
	;x-pos txtBOX
	ldi	yh,@4
	sts	txtBOXposXte,yh
	;y-pos txtBOX
	ldi	yh,@5
	sts	txtBOXposYte,yh
	;
	sts	graphBOXflTE,@6
	call	_GtxtMOD
.endmacro

;*************************************************************************
;rectangle-macro (posX,posY,sizX,sizY,line,flag)
;*************************************************************************
.macro	_graphRECT
	ldi	yh,@0
	sts	txtBOXposXte,yh
	sts	xPOSabs,yh
	;
	ldi	yh,@1
	sts	txtBOXposYte,yh
	sts	yPOSabs,yh
	;
	ldi	yh,@2
	sts	xCHARsiz,yh
	;
	ldi	yh,@3
	sts	yCHARsiz,yh
	;
	ldi	yh,@4
	sts	LINEth,yh
	;
	sts	graphBOXflTE,@5
	call	_DRWrectangle
.endmacro

;***********************************************************************************************
;bargraph-macro-skala (txtL<reg>,txtH<reg>,zoomX,zoomY,posX,posY,sizY,flag<reg>
;-> positionangaben wie bargraph !
;***********************************************************************************************
.macro	_barGRAPHskale
	;skalentext 
	sts	TXTpointL,@0
	sts	TXTpointH,@1
	;x-zoomfaktor
	ldi	yh,@2
	sts	CHARfactorX,yh	
	;y-zoomfaktor
	ldi	yh,@3
	sts	CHARfactorY,yh	
	;x-pos txtBOX
	ldi	yh,@4	
	sts	txtBOXposXte,yh
	;y-pos txtBOX= sizY+3
	ldi	yh,@5
	ldi	zl,3
	ldi	zh,@6	;sizY
	add	yh,zl
	add	yh,zh
	sts	txtBOXposYte,yh
	sts	graphBOXflTE,@7
	call	_GtxtMOD
.endmacro

;***********************************************************************************************
;bargraph-macro-skala (posX,posY,sizY,line,flag<reg>,para<reg>)
;***********************************************************************************************

.macro	_barGRAPH
	;x origin
	ldi	yh,@0
	sts	txtBOXposXte,yh		
	sts	xPOSabs,yh
	;y origin
	ldi	yh,@1
	sts	txtBOXposYte,yh	
	sts	yPOSabs,yh
	;xCHARsiz nicht verndern
	;bargraph umfasst 100 dots !
	ldi	yh,@3
	sts	LINEth,yh			
	;linie *2
	ldi	r17,2
	mul	yh,r17
	ldi	yh,100
	add	yh,r0	
	sts	xCHARsiz,yh
	ldi	yh,@2
	sts	yCHARsiz,yh		
	sts	graphBOXflTE,@4
	sts	paraA,@5
	call	_DRWrectangle
.endmacro


;*************************************************************************
;circle-macro (posX,posY,rad,flag<reg>)
;*************************************************************************

.macro	_graphCIRCLE

	ldi	yh,@2
	sts	radCIRCLE,r16
	;
	sts	graphBOXflTE,@3
	;
	;x-pos GRAPH BOX
	ldi	r16,@0		;	wird spter von anderer stelle geliefert +++
	sts	txtBOXposXte,r16
	sts	xPOSabs,r16		;als absolute x-position speichern
	;y-pos GRAPH BOX
	ldi	r16,@1
	sts	txtBOXposYte,r16
	sts	yPOSabs,r16		;als absolute y-position speichern
	call	_DRWcircle
.endmacro


;*************************************************************************
;line-macro (posX,posY,alpha,length,flag<reg>,quadflag<reg>)
;*************************************************************************

.macro	_graphLINE
	ldi	r16,@3
	sts	lgtLINE,r16
	;
	ldi	r16,@2	;0grad
	sts	alphaLINE,r16
	;
	sts	graphBOXflTE,@4
	;
	sts	quadLINEfl,@5
	;
	;x-pos GRAPH BOX
	ldi	r16,@0
	sts	txtBOXposXte,r16
	;y-pos GRAPH BOX
	ldi	r16,@1
	sts	txtBOXposYte,r16
	call	_PLOTline
.endmacro

;*************************************************************************
;plot-macro (posX,posY,relX,relY,flag<reg>
;*************************************************************************

.macro	_graphPLOT
	;x-pos GRAPH BOX
	ldi	r16,@0
	sts	txtBOXposXte,r16
	;y-pos GRAPH BOX
	ldi	r16,@1
	sts	txtBOXposYte,r16
	;normal/invers
	sts	graphBOXflTE,@4
	;rel x-koordinate
	ldi	r16,@2
	sts	xPLOT,r16
	;rel y-koordinate
	ldi	r16,@3
	sts	yPLOT,r16
	call	_PLOTpix	;pixel setzen
.endmacro