;******************************************************************
;spi-init sub
;******************************************************************
;
;a) master: -generiert clk f. slave
;           -bertragung der daten vom master zum slave
;		-master sendet daten im polling-mode (keine interrupts)
_SPImasterINIT:
	


	;TEST
	;read spsr0	(lscht spif bit)
	in	r16,spsr
	;danach spdr0 lesen
	in	r16,spdr
	;global interrupt clear
	;TEST END






	;global interrupt clear
;	cli	
	;test: zuerst spi disabled
	clr	r16
	out	spcr,r16
	;comFLAGs definieren
	lds	r16,comFLAG
	cbr	r16,1<<spiBUSY	
	cbr	r16,1<<newBUFdata
	sts	comFLAG,r16
	;output-pins
	in	r16,ddrb
	cbr	r16,1<<MISO
	sbr	r16,1<<_SS
	sbr	r16,1<<MOSI
	sbr	r16,1<<SCK ;_SS,MOSI,SCK outputs
	out	ddrb,r16
	;spcr - spi control register
	clr	r16
	sbr	r16,1<<SPE
	sbr	r16,1<<MSTR
	sbr	r16,1<<SPR1;
	sbr	r16,1<<SPR0;enable spi,set mastermode,clk/128,spi interrupt disabled
	out	spcr,r16
	;read spsr	(lscht spif bit)
	in	r16,spsr
	;danach spdr lesen
	in	r16,spdr
	;
	ret











;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;hier beispiel fr bertragungsroutine z. slave
;	
;_SPImasterTX:
;	out	spdr,rxx	;zu bertragende daten
;
;_SPImasterLOOP:
;	sbis	spsr,spif
;	rjmp	_SPImasterLOOP	;warte bis daten bertragen
;	ret				;daten drauen - nun weitere daten bertragen
;					;                oder schlu
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;a) slave : -clk wird von master geliefert
;           -empfang der daten vom master
;		-interrupt-gesteuerter empfang
_SPIslaveINIT:

	

	;TEST
	;read spsr0	(lscht spif bit)
	in	r16,spsr
	;danach spdr0 lesen
	in	r16,spdr
	;global interrupt clear
	;TEST END



	;test: zuerst spi disabled
	clr	r16
	out	spcr,r16
	;daten ist-counter =0
	sts	spiDATctIST,r16

	;
	;output-pins
	in	r16,ddrb
	cbr	r16,1<<SCK
	cbr	r16,1<<MOSI
	cbr	r16,1<<_SS
	sbr	r16,1<<MISO 		;MISO output
	out	ddrb,r16			;ddrb schreiben
	;sck pull up
	in	r16,portb
	cbr	r16,1<<MISO	;test
	sbr	r16,1<<SCK
	out	portb,r16
	;spcr - spi control register
	clr	r16
	sbr	r16,1<<SPE
	sbr	r16,1<<SPIE 	;enable spi,spi interrupt enabled
	out	spcr,r16
	;read spsr	(lscht spif(interrupt-flags) bit)
	in	r16,spsr
	;danach spdr lesen
	in	r16,spdr
	;global interrupt enabled
;	sei	;
	;
	ret
