;-------------------------------------------------------------------------------
;spi - interrupt slave-routine
;-------------------------------------------------------------------------------
;generiert -data-frame (comBUF)
;generiert -flags(comFLAG)-> newBUFdata & spiBUSY
;spiDATctIST = byte counter ist
;spiDATctSOLL= byte counter soll


_SPIslave:
	push	r0	;r0 on stack
	push	r1	;r1 on stack
	push	zh	;zh on stack
	push	zl	;zl on stack
	push	r17	;r17 on stack
	push	r16	;r16 on stack
	push	r15	;r15 on stack
	in	r15,sreg
	;
	;
	;jetzt byte counter laden
	lds	r16,spiDATctIST	
	tst	r16	;erstes byte empfangen
	brne	_SPI02sub
	;comBUF startadresse
	ldi	zh,high(comBUF)
	ldi	zl,low(comBUF)

	;erstes byte aus spi buffer
	in	r16,spdr	;spi register lesen
	st	z+,r16
	;comBUF sichern
	sts	comBUFadrH,zh
	sts	comBUFadrL,zl
	;
	;erstes byte - hier para variable prfen
	sbrc	r16,parG	;noch weiter parameter angehngt?
	rjmp	_SPI04sub	;ja!!
	clr		r16 ;new
	ldi	r17,5		;nein == 6 bytes(-1)
	sts	spiDATctSOLL,r17
	rjmp	_SPI02start	;weiter zur datenbergabe
	;
	;parameter angehngt...
_SPI04sub:
	andi	r16,0b00001111	;nur anzahl der parameter 
	ldi	zl,4			;pro parameter 4 bytes
	ldi	zh,5			;6 bytes (-1)
	mul	zl,r16		;anzahl *4
	add	zh,r0			;6bytes+ xParameter(*4)
	mov	r17,zh		;xBytes gesamt
	sts	spiDATctSOLL,r17
	clr	r16	;new
	jmp	_SPI02start
	;
	;aktuelle comBUF adresse holen
	;& daten speichern
_SPI02sub:
	lds	zh,comBUFadrH
	lds	zl,comBUFadrL
	lds	r17,spiDATctSOLL
	in	r0,spdr	;spi register lesen
	st	z+,r0
	;comBUF sichern
	sts	comBUFadrH,zh
	sts	comBUFadrL,zl
_SPI02start:
	;
	;range prfen
	;&jetzt busy setzen
	lds	zl,comFLAG
	sbr	zl,1<<spiBUSY	;busy...
	;range?
	cp	r16,r17		;ist<soll ?
	brlo	_SPI05sub	
	;>= fertig
	cbr	zl,1<<spiBUSY
	sbr	zl,1<<newBUFdata
	;data counter = 0
	clr	r16

;TEST
	;interrupt disabled
;	in	zh,spcr
;	cbr	zh,1<<SPIE 	;interrupt disabled
;	out	spcr,zh
	;


	rjmp	_SPbk
	;noch nicht erreicht...
_SPI05sub:
	inc	r16
	rjmp	_SPbk	
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
_SPbk:	
	lds	r17,curMODflTE
	cbr	r17,1<<BOXcursor ;cursorroutine disable
	cbr	r17,1<<BOXactiv
	sts	curMODflTE,r17
	;
	sts	spiDATctIST,r16
	sts	comFLAG,zl
	out	sreg,r15
	pop	r15	;restore r15
	pop	r16	;restore r16
	pop	r17	;restore r17
	pop	zl	;restore zl
	pop	zh	;restore zh
	pop	r1	;restore r1
	pop	r0	;restore r0
	reti
